UbixOS V2 2.0

Macros | Typedefs | Functions
mem.h File Reference
`#include <net/opt.h>`
Include dependency graph for mem.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros
#define | MEM_SIZE_F U16_F

## Typedefs
typedef u16_t | mem_size_t

## Functions
void * | mem_calloc (mem_size_t count, mem_size_t size)
void | mem_free (void *mem)
void | mem_init (void)
void * | mem_malloc (mem_size_t size)
void * | mem_trim (void *mem, mem_size_t size)

## Detailed Description

Heap API

Definition in file mem.h.

## Macro Definition Documentation

## ◆ MEM_SIZE_F

#define MEM_SIZE_F U16_F

Definition at line 68 of file mem.h.

## Typedef Documentation

## ◆ mem_size_t

typedef u16_t mem_size_t

Definition at line 67 of file mem.h.

## Function Documentation

## ◆ mem_calloc()

void* mem_calloc | ( | mem_size_t | count,
|  | mem_size_t | size
| ) |  |

Contiguously allocates enough space for count objects that are size bytes of memory each and returns a pointer to the allocated memory.

The allocated memory is filled with bytes of value zero.

Parameters

  count | number of objects to allocate
  size | size of the objects to allocate

Returns
  pointer to allocated memory / NULL pointer if there is an error

Definition at line 765 of file mem.c.

References mem_malloc(), and memset().

Here is the call graph for this function:

## ◆ mem_free()

void mem_free | ( | void * | rmem | ) |

Put a struct mem back on the heap

Parameters

  rmem | is the data portion of a struct mem as returned by a previous call to mem_malloc()

Definition at line 419 of file mem.c.

References LWIP_ASSERT, LWIP_DBG_LEVEL_SERIOUS, LWIP_DBG_TRACE, LWIP_DEBUGF, LWIP_MEM_FREE_DECL_PROTECT, MEM_ALIGNMENT, MEM_DEBUG, and NULL.

Referenced by mem_free_callback(), and pbuf_free().

## ◆ mem_init()

void mem_init | ( | void |  | ) |

Zero the heap and initialize start, end and lowest-free

Definition at line 382 of file mem.c.

References LWIP_ASSERT, MEM_ALIGNMENT, and SIZEOF_STRUCT_MEM.

Referenced by lwip_init().

## ◆ mem_malloc()

void* mem_malloc | ( | mem_size_t | size | ) |

Allocate a block of memory with a minimum of 'size' bytes.

Parameters

  size | is the minimum size of the requested block in bytes.

Returns
  pointer to allocated memory or NULL if no free memory was found.

Note that the returned value will always be aligned (as defined by MEM_ALIGNMENT).

Definition at line 603 of file mem.c.

References LWIP_MEM_ALIGN_SIZE, LWIP_MEM_ALLOC_DECL_PROTECT, MEM_SIZE_ALIGNED, MIN_SIZE_ALIGNED, NULL, and sys_mutex_lock().

Referenced by ethernetif_init(), mem_calloc(), and pbuf_alloc().

Here is the call graph for this function:

## ◆ mem_trim()

void* mem_trim | ( | void * | rmem,
|  | mem_size_t | newsize
| ) |  |

Shrink memory returned by mem_malloc().

Parameters

  rmem | pointer to memory allocated by mem_malloc the is to be shrinked
  newsize | required size after shrinking (needs to be smaller than or equal to the previous size)

Returns
  for compatibility reasons: is always == rmem, at the moment or NULL if newsize is > old size, in which case rmem is NOT touched or freed!

Definition at line 478 of file mem.c.

References LWIP_ASSERT, LWIP_MEM_ALIGN_SIZE, LWIP_MEM_FREE_DECL_PROTECT, MEM_SIZE_ALIGNED, MIN_SIZE_ALIGNED, and NULL.

Referenced by pbuf_realloc().